@echo off
setlocal EnableDelayedExpansion
set serialspeed=38400
set /a progresscounter=0
echo VolvoTech.EU Spider-XL firmware update tool
echo Version 1.000
echo.



:file_ask
color 0F
echo|set /p="Following file(s) are available in the directory: "

rem dir *.bin /b /a-D
echo.
cd firmwares
for /f "tokens=1* delims=:" %%A in ('dir *.bin /b /a-D /b^|findstr /n "^"') do (
  set "file.%%A=%%B"
  set "file.count=%%A"
)

setlocal enableDelayedExpansion
for /l %%N in (1 1 %file.count%) do echo !file.%%N!
echo.
echo %file.count% update files found.

if %file.count% == 1 (	echo The following file has been automatically selected : %file.1%
			set filename=%file.1%
			) 

if %file.count% GTR 1 (set /p filename="Enter update file name :" )		



if [%filename%]==[] goto filename_notexist
IF EXIST %filename% (echo File available for Spider-XL upload) ELSE (goto filename_notexist)

set "cmd=findstr /R /N "^^" %filename% | find /C ":""
for /f %%a in ('!cmd!') do set number=%%a
rem echo %number%
cd ..

echo.
:port_ask
color 0F
rem get serial port from user
echo|set /p="Following com ports are available on this PC: "
FOR /L %%A IN (1,1,50) DO (
  	
	spider-xl COM%%A|find "RTS" >nul
	if not errorlevel 1 (
		echo COM%%A 
		set comportexample="COM%%A"
	)
)
set serialport=
set /p serialport="Enter Serial Port : "

if [%serialport%]==[] goto port_none

spider-xl %serialport%: BAUD=%serialspeed% PARITY=n DATA=8 STOP=1 >nul
if %errorlevel% neq 0 goto :port_error
echo Com port seems OK, connecting to Spider-XL
echo.
ping 127.0.0.1 -n 3 > nul
echo Press any key to start updating now.
cls
color 0C
echo Do NOT remove The Spider-XL from the computer until instructed.
echo.

ping 127.0.0.1 -n 4 > nul
cls
echo Updating the connected Spider-XL
echo Loading file : %filename% 
echo Loading port : %serialport%
echo.
cd firmwares

for /f %%a in ('copy /Z "%~dpf0" nul') do set "CR=%%a"
for /f "tokens=*" %%A in (%filename%) do (

	echo %%A >\\.\%serialport%
 process 50

	set /a progresscount=progresscount+1
	call :show_progress %%A 1
)

color 0A
echo Update succeeded. Press any key to continue.
pause >nul


goto the_end


:filename_notexist
cls
color 0c
echo File not found, trying again.
pause >nul
cls
cd..
goto file_ask

:port_error
cls
color 0c
echo Cannot open %serialport% or no port entered.
pause >nul
cls
goto port_ask

:show_progress
	set /a progress=(progresscount *100) / %number%
	set /p ".=progress: !progress!%%!CR!" <nul
	if !progress! equ 100 echo.
	
exit/b

:the_end
cls
color 0F
echo Thank you for using VolvoTech.EU products.
echo.
echo Press any key to close the update tool, then disconnect the Spider-XL, and (re)connect to your Volvo.
echo.
echo Should you have any questions, please contact us : support@volvotech.eu
pause >nul
exit